function ddump(text)
{
  dump(text + "\n");
}

function ddumpObject(obj, name, maxDepth, curDepth)
{
  if (curDepth == undefined)
    curDepth = 0;
  if (maxDepth != undefined && curDepth > maxDepth)
    return;

  var i = 0;
  for (prop in obj)
  {
    i++;
    if (typeof(obj[prop]) == "object")
    {
      if (obj[prop] && obj[prop].length != undefined)
        ddump(name + "." + prop + "=[probably array, length "
              + obj[prop].length + "]");
      else
        ddump(name + "." + prop + "=[" + typeof(obj[prop]) + "]");
      ddumpObject(obj[prop], name + "." + prop, maxDepth, curDepth+1);
    }
    else if (typeof(obj[prop]) == "function")
      ddump(name + "." + prop + "=[function]");
    else
      ddump(name + "." + prop + "=" + obj[prop]);
  }
  if (!i)
    ddump(name + " is empty");    
}

function WebProgressListener() {
}

WebProgressListener.prototype = {
  _requestsStarted: 0,
  _requestsFinished: 0,

  QueryInterface: function(iid) {
    if (iid.equals(Components.interfaces.nsIWebProgressListener) ||
        iid.equals(Components.interfaces.nsISupportsWeakReference) ||
        iid.equals(Components.interfaces.nsISupports))
      return this;
    
    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  onStateChange: function(webProgress, request, stateFlags, status) {
    const WPL = Components.interfaces.nsIWebProgressListener;

    if (stateFlags & WPL.STATE_IS_REQUEST) {
      if (stateFlags & WPL.STATE_START) {
        this._requestsStarted++;
      } else if (stateFlags & WPL.STATE_STOP) {
        this._requestsFinished++;
      }
    }

    if (stateFlags & WPL.STATE_IS_NETWORK) {
      if (stateFlags & WPL.STATE_STOP) {
        this.onStatusChange(webProgress, request, 0, "Done");
        this._requestsStarted = this._requestsFinished = 0;
      }
    }
  },

  onProgressChange: function(webProgress, request, curSelf, maxSelf,
                             curTotal, maxTotal) {
  },

  onLocationChange: function(webProgress, request, location) {
  },

  onStatusChange: function(webProgress, request, status, message) {
    if (status == 0) {
      /* I haven't figured out why calling print2ps() without a small timeout makes the print
       * component fail. 
       */
      setTimeout('print2ps()', 500);
    }
  },

  onSecurityChange: function(webProgress, request, state) {
  }
};

function print2ps() {
     var browser = document.getElementById("browser");
     var ifreq = content.QueryInterface(Components.interfaces.nsIInterfaceRequestor);
     var webBrowserPrint = ifreq.getInterface(Components.interfaces.nsIWebBrowserPrint);
     var nsCommandLine = window.arguments[0];
     nsCommandLine = nsCommandLine.QueryInterface(Components.interfaces.nsICommandLine);
     var dest = nsCommandLine.getArgument(1);

     gPrintSettings = webBrowserPrint.globalPrintSettings;

     try {
         gPrintSettings.marginTop = 0;
         gPrintSettings.marginBottom = 0;
         gPrintSettings.marginLeft = 0;
         gPrintSettings.marginRight = 0;
         gPrintSettings.footerStrCenter = "";
         gPrintSettings.headerStrRight = "";
	 gPrintSettings.printToFile = true;
	 gPrintSettings.printSilent = true;
	 gPrintSettings.toFileName = dest;
	 gPrintSettings.printerName = "PostScript/default";
	 gPrintSettings.paperName = "A4";
	 gPrintSettings.showPrintProgress = false;
         webBrowserPrint.print(gPrintSettings, null);
     } catch (e) { 
	 ddump(e); 
     }
     window.close();
};

var listener;

function onload() {
  var browser = document.getElementById("browser");
  var nsCommandLine = window.arguments[0];
  nsCommandLine = nsCommandLine.QueryInterface(Components.interfaces.nsICommandLine);
  var from = nsCommandLine.getArgument(0);

  if (nsCommandLine.length != 2) {
    ddump("Wrong number of arguments. Expected <source> <destination>");
    window.close();
  }

  browser.loadURI(from, null, null);
  listener = new WebProgressListener();
  browser.addProgressListener(listener,
    Components.interfaces.nsIWebProgress.NOTIFY_ALL);
}

var browser = document.getElementById("browser");
var nsCommandLine = window.arguments[0];
nsCommandLine = nsCommandLine.QueryInterface(Components.interfaces.nsICommandLine);

if (nsCommandLine.length != 2) {
  ddump("Wrong number of arguments. Expected <source> <destination>");
  window.close();
}

var from = nsCommandLine.getArgument(0);
browser.loadURI(from, null, null);
addEventListener("load", onload, false);
